;*DDK*************************************************************************/
;
; COPYRIGHT (C) Microsoft Corporation, 1989
; COPYRIGHT    Copyright (C) 1995 IBM Corporation
;
;    The following IBM OS/2 WARP source code is provided to you solely for
;    the purpose of assisting you in your development of OS/2 WARP device
;    drivers. You may use this code in accordance with the IBM License
;    Agreement provided in the IBM Device Driver Source Kit for OS/2. This
;    Copyright statement may not be removed.;
;*****************************************************************************/
;*****************************************************************************
;
;  SOURCE FILE NAME = SVGADEFS.INC
;
;  DESCRIPTIVE NAME =
;
;
;  VERSION = V2.0
;
;  DATE
;
;  DESCRIPTION	Contains SVGA definitions.
;
;  FUNCTIONS
;
;  NOTES	When included into VVID sources, ifdef SVGA
;		must be used before #include!
;
;  STRUCTURES
;
;  EXTERNAL REFERENCES
;
;  EXTERNAL FUNCTIONS
;
;  CHANGE ACTIVITY =
;    DATE      FLAG	   APAR	  CHANGE DESCRIPTION
;    --------  ----------  -----  --------------------------------------
;    mm/dd/yy  @Vr.mpppxx  xxxxx  xxxxxxx
;    12/29/92            	  - Created.
;    03/12/93            	  - OEMINFO structure changed.
;    06/07/93            	  - S3 support.
;    08/30/93              73465  - Only need 1 manufacturer value for Diamond
;    08/31/93            	  - Recognize Cirrus Logic GD5428 chip
;    09/14/93              73858  - Range of supported adapters used by DSPINSTL
;    10/06/93              72687  - Recognize Number9 adapter with S3
;    11/02/93              75458  - S3 Merge
;    12/07/93              76476  - Add ID for Chips & Technologies
;    12/15/93              76700  - Add ID for Weitek
;    12/15/93              76685  - Add Artist Graphics manufacturer
; ***************************************************************************

MAX_LOCKUNLOCKCMD	EQU	10
MAX_CLEANDATA	EQU	20


SVGA_ID		EQU	8
SVGA_OEM	EQU	9
SCREENDD_CATEGORY	EQU	080h
SCREENDD_NAME	EQU	"SCREEN$"


DEFAULT_ADAPTER		EQU	(-1)
VIDEO7_ADAPTER	EQU	1
TRIDENT_ADAPTER		EQU	2
TSENG_ADAPTER	EQU	3
WESTERNDIG_ADAPTER	EQU	4
ATI_ADAPTER	EQU	5
IBM_ADAPTER	EQU	6
CIRRUS_ADAPTER	EQU	7
S3_ADAPTER	EQU	8
CHIPS_ADAPTER	EQU	9		       ;          
WEITEK_ADAPTER	EQU	10			;          
 ;remember to update SVGA_LASTADAPTER when adding new adapter support


SVGA_FIRSTADAPTER	EQU	<VIDEO7_ADAPTER>		;          
SVGA_LASTADAPTER	EQU	<WEITEK_ADAPTER>		;          

VIDEO7_HT205_CHIP	EQU	1
VIDEO7_HT208_CHIP	EQU	2
VIDEO7_HT209_CHIP	EQU	3

TRIDENT_8800_CHIP	EQU	1
TRIDENT_8900_CHIP	EQU	2

TSENG_ET3000_CHIP	EQU	1
TSENG_ET4000_CHIP	EQU	2

WESTERNDIG_PVGA1A_CHIP	EQU	1
WESTERNDIG_WD9000_CHIP	EQU	2
WESTERNDIG_WD9011_CHIP	EQU	3
WESTERNDIG_WD9030_CHIP	EQU	4

ATI_18800_CHIP	EQU	1
ATI_28800_CHIP	EQU	2

IBM_SVGA_CHIP	EQU	1

CIRRUS_5422_CHIP	EQU	1
CIRRUS_5424_CHIP	EQU	2
CIRRUS_5426_CHIP	EQU	3
CIRRUS_5428_CHIP	EQU	4	    ;          

S3_86C805_CHIP	EQU	1
S3_86C928_CHIP	EQU	2
S3_86C911_CHIP	EQU	3	    ;          

DIAMOND_MANUFACTURER	EQU	1	    ;          
NUMBER9_MANUFACTURER	EQU	3	    ;          
ARTIST_MANUFACTURER	EQU	4	    ;          
