/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/**********************************************************************/
/*                                                                    */
/*   File            = EDDQCONE                                       */
/*                                                                    */
/*   Description     = Display Device Driver query and escape         */
/*                     constants                                      */
/*                                                                    */
/*   Function        =                                                */
/*                                                                    */
/*   Reference       = Device Driver Interface Specification          */
/*                                                                    */
/*                                                                    */
/**********************************************************************/

/**********************************************************************/
/* Constants used to return info in QueryDeviceCaps                   */
/**********************************************************************/
#define  QRYDEVCAPS_LIST_LENGTH   40

#define  DRIVER_VERSION           0x00000120   /* PM 1.2 */
#define  NO_OF_INT_BMAP_FORMATS   2
#define  NO_OF_DISTINCT_COLOURS   262144

/**********************************************************************/
/* Conversion between metric and imperial coordinate systems          */
/**********************************************************************/
#define INCH_TO_METRE_NOM       3937
#define INCH_TO_METRE_DENOM     100

/**********************************************************************/
/* CAPS_HORIZONTAL_FONT_RES and CAPS_VERTICAL_FONT_RES values at      */
/* different screen resolutions.                                      */
/**********************************************************************/
#define LO_RES_V_FONT_RES       96
#define LO_RES_H_FONT_RES       96
#define RES_800_V_FONT_RES      LO_RES_V_FONT_RES
#define RES_800_H_FONT_RES      LO_RES_H_FONT_RES
#define HI_RES_V_FONT_RES       120
#define HI_RES_H_FONT_RES       120
