;*DDK*************************************************************************/
;
; COPYRIGHT (C) Microsoft Corporation, 1989
; COPYRIGHT    Copyright (C) 1995 IBM Corporation
;
;    The following IBM OS/2 WARP source code is provided to you solely for
;    the purpose of assisting you in your development of OS/2 WARP device
;    drivers. You may use this code in accordance with the IBM License
;    Agreement provided in the IBM Device Driver Source Kit for OS/2. This
;    Copyright statement may not be removed.;
;*****************************************************************************/
;/*****************************************************************************
;*
;* SOURCE FILE NAME = PHOENIX.INC
;*
;* DESCRIPTIVE NAME = ATLAS video adaptor definitions
;*
;*
;* VERSION      V2.0
;*
;* DATE
;*
;* DESCRIPTION
;*
;* FUNCTIONS    NONE
;*
;* NOTES        NONE
;*
;* STRUCTURES   NONE
;*
;* EXTERNAL REFERENCES
;*
;*              NONE
;*
;* EXTERNAL FUNCTIONS
;*
;*              NONE
;*
;* CHANGE ACTIVITY =
;*   DATE      FLAG        APAR    CHANGE DESCRIPTION
;*   --------  ----------  -----   --------------------------------------
;*   mm/dd/yy  @Vr.mpppxx  xxxxx   xxxxxxx
;*   10/24/88  J-KK                KKJ Change lablel to XXXJ.
;*             J-KK0814            KKJ Added Card ID of ATLAS-KENT
;*   04/25/90  @camel              KKJ, Added Card ID of ATLAS-II
;*   12/26/90  @IDS                KKJ, Added Card ID of ATLAS-IDS
;*   07/25/91  @ATLAS-SP2          KKJ, Added Card ID of ATLAS-SP2
;*
;*****************************************************************************/

;                                                                       ;SK0006
; Adapter Card ID                                                       ;SK0006
;                                                                       ;SK0006
ToledoId        equ     0efffh  ; Card ID for Toledo display adapter    ;RH000P
AtlasIDS        equ     0EFEBh  ; Card ID for Atlas IDS display adapter ;@IDS
AtlasId         equ     0effeh  ; Card ID for Atlas display adapter     ;SK0001
AtlasEVTId      equ     0ffedh  ; Card ID for Atlas EVT display adapter ;SK0001
AtlasKENT       equ     0ECECh  ; Card ID for AtlasKENT display adapter ;J-KK0814
AtlasSP2        equ     0EFD8h  ; Card ID for Atlas-SP2 display adapter ;@ATLAS-SP2
LDTId           equ     0e013h  ; Card ID for LDT display adapter       ;SK0006
LDTEVTId        equ     0fffdh  ; Card ID for LDT EVT display adapter   ;SK0006

AtlasII_Start   equ     9000h   ; Card ID Range Start for ATLAS II      ;@camel
AtlasII_End     equ     901Fh   ; Card ID Range End   for ATLAS II      ;@camel

;
; Flag for AdapterFlag                                                  ;SK0001
;                                                                       ;SK0001
Atlas           equ     0                                               ;SK0001
Toledo          equ     1                                               ;SK0001
;
PHOENIX_16G     EQU     12              ; 720X512 COLOLR GRAPHIC MODE
PHOENIX_24G     EQU     13              ; 1024X768 COLOLR GRAPHIC MODE
Mck256Color     equ     15                                              ;SK0001
MultiPageColor  equ     16                                              ;SK0001
;
; PHOENIX CARD INTERNAL ADDRESS REGISTERS
;
AC_REG          EQU     3EEH
  AC_DMAE               EQU     80H
  FONT_SEL              EQU     40H
FONT_BANK       EQU     3EFH
LS_PORT         EQU     3E0H
  LS_RESET              EQU     00H
  LS_MODE               EQU     02H
  LS_CONFIG             equ     0ah                                     ;SK0001
LF_PORT         equ     3e2h                                            ;SK0001
LC_PORT         EQU     3E4H
  HORIZONTAL_TOTAL      EQU     00H
  H_DISPLAY_ENABLE_END  EQU     01H
  START_H_BLANKING      EQU     02H
  END_H_BLANKING        EQU     03H
  START_HSYNC_PULSE     EQU     04H
  END_HSYNC_PULSE       EQU     05H
  VERTICAL_TOTALJ       EQU     06H             ;;J-KK
  CRTC_OVERFLOW         EQU     07H
  PRESET_ROW_SCANJ      EQU     08H             ;;J-KK
  MAXIMUM_SCAN_LINE     EQU     09H
  START_ADDRESS_HIGH    EQU     0CH
  START_ADDRESS_LOW     EQU     0DH
  CURSOR_LOC_HIGH       EQU     0EH
  ROW_CURSOR_LOC        EQU     0EH
  CURSOR_LOC_LOWJ       EQU     0FH             ;;J-KK
  COLUMN_CURSOR_LOC     EQU     0FH
  VERTICAL_SYNC_START   EQU     10H
  LIGHT_PEN_HIGH        EQU     10H
  VERTICAL_SYNC_END     EQU     11H
  LIGHT_PEN_LOW         EQU     11H
  V_DISPLAY_ENABLE_END  EQU     12H
  LC_OFFSET             EQU     13H
  UNDERLINE_LOCATION    EQU     14H
  START_VERTICAL_BLANK  EQU     15H
  END_VERTICAL_BLANK    EQU     16H
  LC_MODE_CONTROL       EQU     17H
  LINE_COMPAREJ         EQU     18H             ;;J-KK
  START_H_DISPLAY_ENAB  EQU     19H
  START_V_DISPLAY_ENAB  EQU     1AH
  VIEWPORT_COMMAND      EQU     1BH
  VIEWPORT_SELECT       EQU     1CH
  VIEWPORT_PRIORITY     EQU     1DH
  LC_COMMAND            EQU     1EH
  LC_COMPATIBILITY      EQU     1FH
  VIEWPORT_NUMBER       EQU     1FH
LV_PORT         EQU     3E8H
  PALETTE_0             EQU     00H
  LV_MODE_CONTROL       EQU     10H
  OVERSCAN_COLOR        EQU     11H
  COLOR_PLANE_ENAB      EQU     12H
  PANNING               EQU     13H
  VIEWPORT1_BG          EQU     14H
  VIEWPORT2_BG          EQU     15H
  VIEWPORT3_BG          EQU     16H
  BLINK_COLOR           EQU     17H
  BLINK_CODE            EQU     18H
  GR_CURSOR_ROTATION    EQU     19H
  GR_CURSOR_COLOR       EQU     1AH
  GR_CURSOR_CONTROL     EQU     1BH
  LV_COMMAND            EQU     1CH
  VP_BORDER_LINE        EQU     1DH
  SYNC_POLARITY         EQU     1FH
  CURSOR_CODE_0         EQU     20H
  GRID_COLOR_0          EQU     34H
  GRID_COLOR_1          EQU     35H
  GRID_COLOR_2          EQU     36H
  GRID_COLOR_3          EQU     37H
  ATTRIBUTE_CNTL        EQU     38H
  CURSOR_COLOR          EQU     3AH
  CURSOR_CONTROL        EQU     3BH
  RAS_STATUS_VIDEO      EQU     3CH
  PAS_STATUS_CNTRL      EQU     3DH
  IDENTIFICATION        EQU     3EH
  OUTPUT                EQU     3EH
  LV_COMPATIBILITY      EQU     3FH
LA_PORT         EQU     3E8H
LG_PORT         EQU     3EAH
  SET_RESETJ            EQU     00H             ;;J-KK
  ENABLE_SRJ            EQU     01H             ;;J-KK
  COLOR_COMPAREJ        EQU     02H             ;;J-KK
  DATA_ROTATION         EQU     03H
  READ_MAP_SELECT       EQU     04H
  LG_MODE               EQU     05H
  COMPLEMENT            EQU     06H
  COLOR_DONT_CARE       EQU     07H
  BIT_MASK_LOW          EQU     08H
  BIT_MASK_HIGH         EQU     09H
  MAP_MASKJ             EQU     0AH             ;;J-KK
  LG_COMMAND            EQU     0BH
  SET_RESET_2           EQU     10H


LS_PORT EQU     3E0H
LD_PORT EQU     3E2H
LV_PORT EQU     3E8H                            ;J-KKB17
