/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/******************************************************************************/
/* Module Name: RESOURCE.H                                                    */
/*                                                                            */
/* Created: 15-Oct-1991                                                       */
/* Author:  Soh Ohta     [jl09057 @ ymtvm3, IBM Japan]                        */
/*                                                                            */
/*                       Refer to Copyright Inscruction Form No.G120-2083     */
/*                                                                            */
/* Exported Functions:   none                                                 */
/*                                                                            */
/* Public Functions:     none                                                 */
/*                                                                            */
/* Public Data:          none                                                 */
/*                                                                            */
/* General Description:                                                       */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* Physical font resource id.                                                 */
/******************************************************************************/

#define PRESID_MINPRO_08x18      100
#define PRESID_MINPRO_11x24      101
#define PRESID_MINPRO_12x26      102
#define PRESID_MINSYS_07x16      103
#define PRESID_MINSYS_09x20      104
#define PRESID_MINSYS_11x24      105
#define PRESID_MINSYS_13x28      106
#define PRESID_MINSYS_16x34      107
#define PRESID_MINSYS_17x36      108
#define PRESID_MINSYS_23x48      109

#define PRESID_GOTPRO_08x18      200
#define PRESID_GOTPRO_11x24      201
#define PRESID_GOTSYS_07x16      202
#define PRESID_GOTSYS_09x20      203
#define PRESID_GOTSYS_11x24      204
#define PRESID_GOTSYS_13x28      205
#define PRESID_GOTSYS_16x34      206
#define PRESID_GOTSYS_17x36      207
#define PRESID_GOTSYS_23x48      208

/******************************************************************************/
/* Virtual font resource id (FOCAFONT structure).                             */
/******************************************************************************/

#define VRESID_MINPRO_08x18     1000    // MINCHO Proportional
#define VRESID_MINPRO_16x18     1001
#define VRESID_MINPRO_11x24     1002
#define VRESID_MINPRO_22x24     1003
#define VRESID_MINPRO_12x26     1004
#define VRESID_MINPRO_24x26     1005

#define VRESID_MINSYS_06x14     1100    // MINCHO System
#define VRESID_MINSYS_12x14     1101
#define VRESID_MINSYS_07x16     1102
#define VRESID_MINSYS_14x16     1103
#define VRESID_MINSYS_08x18     1104
#define VRESID_MINSYS_16x18     1105
#define VRESID_MINSYS_09x20     1106
#define VRESID_MINSYS_18x20     1107
#define VRESID_MINSYS_11x24     1108
#define VRESID_MINSYS_22x24     1109
#define VRESID_MINSYS_13x28     1110
#define VRESID_MINSYS_26x28     1111
#define VRESID_MINSYS_15x32     1112
#define VRESID_MINSYS_30x32     1113
#define VRESID_MINSYS_16x34     1114
#define VRESID_MINSYS_32x34     1115
#define VRESID_MINSYS_17x36     1116
#define VRESID_MINSYS_34x36     1117
#define VRESID_MINSYS_19x40     1118
#define VRESID_MINSYS_38x40     1119
#define VRESID_MINSYS_23x48     1120
#define VRESID_MINSYS_46x48     1121

#define VRESID_MINCHO_06x12     1200    // MINCHO
#define VRESID_MINCHO_12x12     1201
#define VRESID_MINCHO_07x14     1202
#define VRESID_MINCHO_14x14     1203
#define VRESID_MINCHO_08x16     1204
#define VRESID_MINCHO_16x16     1205
#define VRESID_MINCHO_09x18     1206
#define VRESID_MINCHO_18x18     1207
#define VRESID_MINCHO_10x20     1208
#define VRESID_MINCHO_20x20     1209
#define VRESID_MINCHO_12x24     1210
#define VRESID_MINCHO_24x24     1211
#define VRESID_MINCHO_14x28     1212
#define VRESID_MINCHO_28x28     1213
#define VRESID_MINCHO_15x30     1214
#define VRESID_MINCHO_30x30     1215
#define VRESID_MINCHO_16x32     1216
#define VRESID_MINCHO_32x32     1217
#define VRESID_MINCHO_18x36     1218
#define VRESID_MINCHO_36x36     1219
#define VRESID_MINCHO_20x40     1220
#define VRESID_MINCHO_40x40     1221

#define VRESID_MINTRM_08x12     1800    // MINCHO Terminal
#define VRESID_MINTRM_16x12     1801
#define VRESID_MINTRM_08x14     1802
#define VRESID_MINTRM_16x14     1803

#define VRESID_MINDRF_06x12     1900    // MINCHO DRAFT
#define VRESID_MINDRF_12x12     1901
#define VRESID_MINDRF_07x14     1902
#define VRESID_MINDRF_14x14     1903
#define VRESID_MINDRF_08x16     1904
#define VRESID_MINDRF_16x16     1905
#define VRESID_MINDRF_09x18     1906
#define VRESID_MINDRF_18x18     1907
#define VRESID_MINDRF_10x20     1908
#define VRESID_MINDRF_20x20     1909
#define VRESID_MINDRF_11x22     1910
#define VRESID_MINDRF_22x22     1911
#define VRESID_MINDRF_16x32     1912
#define VRESID_MINDRF_32x32     1913
#define VRESID_MINDRF_18x36     1914
#define VRESID_MINDRF_36x36     1915
#define VRESID_MINDRF_24x48     1916
#define VRESID_MINDRF_48x48     1917

#define VRESID_GOTPRO_08x18     2000    // GOTHIC Proportional
#define VRESID_GOTPRO_16x18     2001
#define VRESID_GOTPRO_11x24     2002
#define VRESID_GOTPRO_22x24     2003

#define VRESID_GOTSYS_06x14     2100    // GOTHIC System
#define VRESID_GOTSYS_12x14     2101
#define VRESID_GOTSYS_07x16     2102
#define VRESID_GOTSYS_14x16     2103
#define VRESID_GOTSYS_08x18     2104
#define VRESID_GOTSYS_16x18     2105
#define VRESID_GOTSYS_09x20     2106
#define VRESID_GOTSYS_18x20     2107
#define VRESID_GOTSYS_11x24     2108
#define VRESID_GOTSYS_22x24     2109
#define VRESID_GOTSYS_13x28     2110
#define VRESID_GOTSYS_26x28     2111
#define VRESID_GOTSYS_15x32     2112
#define VRESID_GOTSYS_30x32     2113
#define VRESID_GOTSYS_16x34     2114
#define VRESID_GOTSYS_32x34     2115
#define VRESID_GOTSYS_17x36     2116
#define VRESID_GOTSYS_34x36     2117
#define VRESID_GOTSYS_19x40     2118
#define VRESID_GOTSYS_38x40     2119
#define VRESID_GOTSYS_23x48     2120
#define VRESID_GOTSYS_46x48     2121

#define VRESID_GOTHIC_06x12     2200    // GOTHIC
#define VRESID_GOTHIC_12x12     2201
#define VRESID_GOTHIC_07x14     2202
#define VRESID_GOTHIC_14x14     2203
#define VRESID_GOTHIC_08x16     2204
#define VRESID_GOTHIC_16x16     2205
#define VRESID_GOTHIC_09x18     2206
#define VRESID_GOTHIC_18x18     2207
#define VRESID_GOTHIC_10x20     2208
#define VRESID_GOTHIC_20x20     2209
#define VRESID_GOTHIC_12x24     2210
#define VRESID_GOTHIC_24x24     2211
#define VRESID_GOTHIC_14x28     2212
#define VRESID_GOTHIC_28x28     2213
#define VRESID_GOTHIC_15x30     2214
#define VRESID_GOTHIC_30x30     2215
#define VRESID_GOTHIC_16x32     2216
#define VRESID_GOTHIC_32x32     2217
#define VRESID_GOTHIC_18x36     2218
#define VRESID_GOTHIC_36x36     2219
#define VRESID_GOTHIC_20x40     2220
#define VRESID_GOTHIC_40x40     2221

#define VRESID_GOTTRM_08x12     2800    // GOTHIC Terminal
#define VRESID_GOTTRM_16x12     2801
#define VRESID_GOTTRM_08x14     2802
#define VRESID_GOTTRM_16x14     2803

